=== debian/changelog ===
torque3d (1.1.0.0-1mx17+1) mx; urgency=medium

  * Repackaged for MX Linux.

 -- Mike Purtell <mandbx@sbcglobal.net>  Thu, 26 Oct 2017 20:40:35 -0400

torque3d (1.1.0.0-1~getdeb1) xenial; urgency=medium

  * New upstream version

 -- Christoph Korn <christoph.korn@getdeb.net>  Sat, 30 Sep 2017 19:35:45 +0200

torque3d (1.0.9.0-1~getdeb1) xenial; urgency=medium

  * Initial release

 -- Christoph Korn <christoph.korn@getdeb.net>  Fri, 28 Jul 2017 18:35:01 +0200
