=== debian/control ===
Source: torque3d
Section: games
Priority: optional
Maintainer: Mike Purtell (mmikeinsantarosa) <maintainer@mepiscommunity.org>
XSBC-Original-Maintainer: Christoph Korn <christoph.korn@getdeb.net>
Build-Depends: debhelper (>= 9),
               cmake,
               nasm,
               xorg-dev,
               ninja-build,
               gcc-multilib,
               g++-multilib,
               libogg-dev,
               libxft-dev,
               libx11-dev,
               libxxf86vm-dev,
               libopenal-dev,
               libfreetype6-dev,
               libxcursor-dev,
               libxinerama-dev,
               libxi-dev,
               libxrandr-dev,
               libxss-dev,
               libglu1-mesa-dev,
               libgtk-3-dev,
               libsdl2-dev,
               chrpath
Standards-Version: 3.9.7
Homepage: https://github.com/Duion/Torque3D

Package: torque3d
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Torque 3D
 MIT Licensed Open Source version of Torque 3D from GarageGames
