=== debian/watch ===
version=3
https://github.com/Duion/Torque3D/releases \
    (?:.*/)?([\d\.]+)\.tar\.gz
